
  var utils = require('./utils/Utils');

  
  /**
   * 堆叠柱状图 的API, 组件ID为comp-zb5e08LIzv, API的ID为Azz488566927
   * 该组件位于第1页，左上角(15, 60)位置， 宽高546x358.6715462031107, 旋转0deg
   */
  function mock__152OH0V59990() {
    var data = {"title":"2020年华北/华东地区为主要产品市场","content":[["数据",2010,2011,2012,2013,2014,2015],["东北",2343,716,701,465,1074,600],["华东",2978,3010,3943,2805,2294,3168],["华中",261,592,1092,205,579,569],["华北",2910,4571,3533,3864,4100,3275],["华南",244,205,407,1681,1110,403],["西北",681,459,402,658,285,500],["西南",2202,1098,721,455,953,1112]],"mergedCells":[]};
    return utils.randomify(data, {type: 'ChartColumn-Stacked', category: 'ChartColumn', defCode: 'bMRCKzbNW'});
  }
  


  /**
   * 百分比堆叠面积图 的API, 组件ID为comp-H0rwgMz_nj, API的ID为1l515019j217
   * 该组件位于第1页，左上角(562, 61)位置， 宽高546x358.6715462031107, 旋转0deg
   */
  function mock__1V068864h194() {
    var data = {"content":[["数据",2010,2011,2012,2013,2014,2015],["东北",2343,716,701,465,1074,600],["华东",2978,3010,3943,2805,2294,3168],["华中",261,592,1092,205,579,569],["华北",2910,4571,3533,3864,4100,3275],["华南",244,205,407,1681,1110,403],["西北",681,459,402,658,285,500],["西南",2202,1098,721,455,953,1112]],"mergedCells":[],"title":" 百分比堆叠面积图"};
    return utils.randomify(data, {type: 'ChartLine-Stacked', category: 'ChartLine', defCode: 'JXEdF3pot'});
  }
  


  /**
   * 表格H1V1 的API, 组件ID为comp-15MD0EY5Qh, API的ID为K1061X354363
   * 该组件位于第1页，左上角(15, 420)位置， 宽高1092.9990609319652x358.6720837358362, 旋转0deg
   */
  function mock__2z2s849394d4() {
    var data = {"content":[["科目","张三","李四","王五","赵六"],["语文",78,82,86,69],["数学",96,86,92,98],["英语",82,72,85,68],["历史",76,90,90,76],["地理",78,92,89,78],["体育",92,78,80,90]],"mergedCells":[],"title":"张李王赵家的孩子初中成绩对比"};
    return utils.randomify(data, {type: 'Table-Basic', category: 'Table', defCode: 'Yi7IaJQWS'});
  }
  

  var funcsMap = {
    "152OH0V59990": mock__152OH0V59990,
    "1V068864h194": mock__1V068864h194,
    "2z2s849394d4": mock__2z2s849394d4
  };

  function getMockDataByCode(code) {
    var func = funcsMap[code];
    try{
      if(func) {
        return func();
      }
    }catch(e){ }
    return [];
  }

  module.exports = function(app) {
    
    /**
     * 这是Mock的API入口，根据参数code不同调用不同函数分支
     */
     app.get('/api/data/mock/predefined', function (req, res) {
        var code = req.query.code;
        var mockData = getMockDataByCode(code);
        res.writeHead(200, {'Content-Type':'application/json;charset=UTF-8'});
        res.end(JSON.stringify({
          "code":"0",
          "success": true,
          "data": JSON.stringify(mockData)
        }));
     });
    
  }
  