var _ = require('lodash');

// var SPECIAL_RANDOMIFY_MAP = {
//   BasicEProgressGaugeChart: function(data) { data.content[1][1] = _.random(0, 100, false); return data; },
//   BasicERatioPieChart: function(data) { data.content[1][1] = _.random(0, 100, true, 2); return data; },
//   BasicELiquidFillChart: function(data) {
//     data.content[1][1] = _.random(0.4, 1, true, 1);
//     data.content[1][2] = _.random(0.2, data.content[1][1], true, 1);
//     data.content[1][3] = _.random(0, data.content[1][2], true, 1);
//     return data;
//   },
//   BasicECircleLabelChart: function(data) { data.content[1][1] = _.random(10000, 999999, false) + '亿'; return data; },
//   BasicEGaugeChart: function(data) { data.content = _.random(0, 1, true, 1); return data; }
// };

var SPECIAL_RANDOMIFY_MAP = {
  'p9DSrNZ7K': function(data) { data.content[1][1] = _.random(0, 100, false); return data; }, // 进度仪表盘
  '_a3XnlEBM': function(data) { data.content[1][1] = _.random(0, 100, true, 2); return data; }, // 进度环形图
  'KpPGiz3mF': function(data) {
    data.content[1][1] = _.random(0.4, 1, true, 1);
    data.content[1][2] = _.random(0.2, data.content[1][1], true, 1);
    data.content[1][3] = _.random(0, data.content[1][2], true, 1);
    return data;
  },
  // BasicECircleLabelChart: function(data) { data.content[1][1] = _.random(10000, 999999, false) + '亿'; return data; },
  'cgzonQP1l': function(data) { data.content = _.random(0, 1, true, 1); return data; } //  // 仪表盘
};

function transpose(matrix) {
  var rows = matrix ? matrix.length : 0;
  var record = rows ? matrix[0] : null;
  var cols = record ? record.length : 0;

  if (!rows || !cols) {
    return matrix;
  }
  let grid = [];

  for (var col = 0; col < cols; col++) {
    grid[col] = [];
  }
  for (var row = 0; row < rows; row++) {
    for (var col = 0; col < cols; col++) {
      grid[col][row] = matrix[row][col];
    }
  }
  return grid;
}

function randomify(data, extra) {

  // var extraType = (extra || {}).type;
  // var randomifySepcial = extraType ? SPECIAL_RANDOMIFY_MAP[extraType] : null;
  var defCode = (extra || {}).defCode;
  var randomifySepcial = defCode ? SPECIAL_RANDOMIFY_MAP[defCode] : null;

  if(randomifySepcial) {
    return randomifySepcial(data);
  }

  var content = data.content;
  if(!_.isArray(content)) {
    return data;
  }

  var arrTransposed = transpose(content);
  let colMinMaxArr = [];

  for(var i = 1; i < arrTransposed.length; i++) {
    var row = arrTransposed[i];
    var minVal = Number.MAX_VALUE;
    var maxVal = Number.MIN_VALUE;


    for(var j = 1; j < row.length; j++) {
      var val = row[j];
      if(_.isNumber(val)) {
        minVal = val < minVal ? val : minVal;
        maxVal = val > maxVal ? val : maxVal;
      }
    }

    var floating = _.indexOf(String(minVal), '.') > -1 || _.indexOf(String(maxVal), '.') > -1;

    let num1precision = String(minVal).length - String(minVal).indexOf('.') - 1;
    let num2precision = String(maxVal).length - String(maxVal).indexOf('.') - 1;
    let precision = floating ? _.max([num1precision, num2precision, 0]) : 0;

    colMinMaxArr.push({ minVal, maxVal, floating, precision });
  }
  // console.log('arrTransposed', arrTransposed);
  // console.log('colMinMaxArr', colMinMaxArr);

  for(var i = 1; i < content.length; i++) {
    var row = content[i] || [];
    for(var j = 1; j < row.length; j++) {
      var val = row[j];
      if(_.isNumber(val) && val !== 0 && val !== 100) {
        var minMaxVals = colMinMaxArr[j - 1]; // 按列取
        // console.log('minMaxVals', minMaxVals);
        var num = _.random(minMaxVals.minVal, minMaxVals.maxVal, minMaxVals.floating);
        num = minMaxVals.precision ? parseFloat(num.toFixed(minMaxVals.precision)) : num;
        content[i][j] = num;
      }
    }
  }

  return data;
}


module.exports = {
  randomify: randomify,
  transpose: transpose
};

// var data = {"content":[["名称","数值","单位","最小值","最大值"],["速度",80,"%",0,100]],"mergedCells":[]};
// var data1 = randomify(data);
// console.log(data1);
